#!/usr/bin/python

import math
import sys

"""This program iterates the unit square under the iteration
x' = x + y
y' = y + epsilon*sin(2pi*x)
with both calculations modulo 1.0.

The system iterates a series of points whose initial positions form
an nx by ny regular grid on the unit square.  Each point is iterated
"n_iter" many times.
"""

twopi = 2.0*math.pi

nx = int(sys.argv[1])
if nx <= 0:
    raise Exception('nx must be positive: %d given' % nx)

ny = int(sys.argv[2])
if ny <= 0:
    raise Exception('ny must be positive: %d given' % ny)

n_iter = int(sys.argv[3])
if n_iter <= 0:
    raise Exception('n_iter must be positive. %d given' % n_iter)

epsilon = float(sys.argv[4])

# print '%d\t%d\t%d\t%f' % (nx, ny, n_iter, epsilon)

for ix in range(0, nx):
    for iy in range(0, ny):
        x = float(ix)/float(nx)
        y = float(iy)/float(ny)
        for count in range(0, n_iter):
            xx = x + y
            yy = y*(1.0 + epsilon*math.sin(twopi*x))
            x = xx - math.floor(xx)
            y = yy - math.floor(yy)
        print "%f\t%f" % (x,y)
